VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Focuser"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Description = "ASCOM Focuser driver for Focuser Simulator"

Option Explicit

' ------------
' Class Events
' ------------

Private Sub Class_Initialize()

    If Not g_bRunExecutable Then _
        g_iConnections = g_iConnections + 1
        
    g_handBox.Position = Position
End Sub

Private Sub Class_Terminate()
    
    If Not g_bRunExecutable Then
        If g_iConnections > 1 Then
            g_iConnections = g_iConnections - 1
        Else
            Unload g_handBox
        End If
    End If
    
End Sub

' ----------
' Properties
' ----------

Public Property Get Absolute() As Boolean

    Absolute = 1
    
    If Not g_show Is Nothing Then
        If g_show.chkOther.Value = 1 Then _
            g_show.TrafficLine "Absolute: " & Absolute
    End If

End Property

Public Property Get IsMoving() As Boolean

  
    check_connected
    ' mrh - how best to do this?
    IsMoving = False
    
End Property

Public Property Get Link() As Boolean

    Link = Servo.IsAttached
    
    If Not g_show Is Nothing Then
        If g_show.chkOther.Value = 1 Then _
            g_show.TrafficLine "Link: " & Link
    End If
      
End Property

Public Property Let Link(ByVal newVal As Boolean)

    Dim out As String

    If Not g_show Is Nothing Then
        If g_show.chkOther.Value = 1 Then _
            g_show.TrafficStart "Link: " & Link & " -> " & newVal
    End If
    
    If newVal Then
        If Not Link Then
            Servo.Open (False)
        End If
    Else
        If Link Then
            Servo.Close
        End If
    End If
    
    If Not g_show Is Nothing Then
        If g_show.chkOther.Value = 1 Then _
            g_show.TrafficEnd out
    End If
    
End Property

Public Property Get MaxIncrement() As Long

    MaxIncrement = MaxStep
    
    If Not g_show Is Nothing Then
        If g_show.chkOther.Value = 1 Then _
            g_show.TrafficLine "MaxIncrement: " & MaxIncrement
    End If

End Property

Public Property Get MaxStep() As Long

    MaxStep = 10 * (g_lMaxDeg - g_lMinDeg)

    If Not g_show Is Nothing Then
        If g_show.chkOther.Value = 1 Then _
            g_show.TrafficLine "MaxStep: " & MaxStep
    End If

End Property



Public Property Get StepSize() As Double
    
    StepSize = g_dStepSize
    If Not g_show Is Nothing Then
        If g_show.chkOther.Value = 1 Then _
            g_show.TrafficStart "StepSize: " & g_dStepSize
    End If
    
    '    Err.Raise SCODE_NOT_IMPLEMENTED, ERR_SOURCE, _
    '        "Property StepSize" & MSG_NOT_IMPLEMENTED

End Property

Public Property Get TempComp() As Boolean

    If Not g_show Is Nothing Then
        If g_show.chkTemp.Value = 1 Then _
            g_show.TrafficStart "TempComp: "
    End If
    
    check_connected
    
    ' do not throw error if not implemented, just return false
    TempComp = False

End Property

Public Property Let TempComp(ByVal newVal As Boolean)

            Err.Raise SCODE_NOT_IMPLEMENTED, ERR_SOURCE, _
                "Property TempComp" & MSG_NOT_IMPLEMENTED
  
End Property

Public Property Get TempCompAvailable() As Boolean


    TempCompAvailable = False
    
End Property

Public Property Get Temperature() As Double
   
        Err.Raise SCODE_NOT_IMPLEMENTED, ERR_SOURCE, _
            "Property Temperature" & MSG_NOT_IMPLEMENTED
    
    
End Property

' -------
' Methods
' -------

Public Sub Halt()
    
        Err.Raise SCODE_NOT_IMPLEMENTED, ERR_SOURCE, _
            "Halt" & MSG_NOT_IMPLEMENTED
    
End Sub

Public Sub SetupDialog()
    
    If Not g_show Is Nothing Then
        If g_show.chkOther.Value = 1 Then _
            g_show.TrafficStart "SetupDialog"
    End If
    
    DoSetup
    
    If Not g_show Is Nothing Then
        If g_show.chkOther.Value = 1 Then _
            g_show.TrafficEnd " (done)"
    End If
    
End Sub
Public Property Get Position() As Long

    check_connected
    Position = fromDegrees(Servo.MotorPosition(0))
    '0.5 + 10 * (Servo.MotorPosition(0) - g_lMinDeg)
    g_handBox.Position = Position
    
    If Not g_show Is Nothing Then
        If g_show.chkOther.Value = 1 Then _
            g_show.TrafficStart "Position: " & Position
    End If
            
    
End Property
Public Sub Move(ByVal val As Long)


    If Not g_show Is Nothing Then
        If g_show.chkMove.Value = 1 Then _
            g_show.TrafficStart "Move: " & val
    End If
      
    check_connected
    
    Servo.MotorPosition(0) = toDegrees(val)
  
End Sub

'---------------------------------------------------------------------
'
' check_connected() - Raise an error if the focuser is not connected
'
'---------------------------------------------------------------------
Private Sub check_connected()
    
    If Not Servo.IsAttached Then _
        Err.Raise SCODE_NOT_CONNECTED, ERR_SOURCE, MSG_NOT_CONNECTED
        
End Sub
