VERSION 5.00
Begin VB.Form frmHandBox 
   BackColor       =   &H00000000&
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Phidget Focuse"
   ClientHeight    =   2640
   ClientLeft      =   45
   ClientTop       =   255
   ClientWidth     =   1980
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   2640
   ScaleWidth      =   1980
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdTraffic 
      Caption         =   "Traffic"
      Height          =   330
      Left            =   1080
      TabIndex        =   4
      ToolTipText     =   "Bring up Setup dialog"
      Top             =   840
      Width           =   825
   End
   Begin VB.PictureBox picASCOM 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   840
      Left            =   630
      MouseIcon       =   "frmHandBox.frx":0000
      MousePointer    =   99  'Custom
      Picture         =   "frmHandBox.frx":0152
      ScaleHeight     =   840
      ScaleWidth      =   720
      TabIndex        =   2
      TabStop         =   0   'False
      ToolTipText     =   "Click to go to the ASCOM web site"
      Top             =   1320
      Width           =   720
   End
   Begin VB.CommandButton cmdSetup 
      Caption         =   "Setup"
      Height          =   330
      Left            =   120
      TabIndex        =   3
      ToolTipText     =   "Bring up Setup dialog"
      Top             =   840
      Width           =   825
   End
   Begin VB.Label PositionTF 
      Alignment       =   1  'Right Justify
      Appearance      =   0  'Flat
      BackColor       =   &H00000000&
      Caption         =   "0"
      BeginProperty Font 
         Name            =   "Courier"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   255
      Left            =   840
      TabIndex        =   1
      Top             =   240
      Width           =   945
   End
   Begin VB.Label PositionL 
      BackColor       =   &H00000000&
      Caption         =   "Position:"
      ForeColor       =   &H00FFFFFF&
      Height          =   225
      Left            =   120
      TabIndex        =   0
      Top             =   240
      Width           =   690
   End
End
Attribute VB_Name = "frmHandBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit
Private WithEvents PhidgetManager As PhidgetManager
Attribute PhidgetManager.VB_VarHelpID = -1

' button handling variables
Private BtnState As Integer         ' current state
Private BtnDebounce As Integer      ' hold key for fetch even of up occured
Private downclick As Boolean        ' button just went down - state unclear

' ======
' EVENTS
' ======

Private Sub Form_Load()

    FloatWindow Me.hwnd, g_bAlwaysTop
    
    'initialize variables
    BtnState = 0
    BtnDebounce = 0
    downclick = False
    Set PhidgetManager = New PhidgetManager
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    ' force clean state
    BtnState = 0
    BtnDebounce = 0
    downclick = False
    On Error Resume Next
    Unload frmSetup
    If Not g_show Is Nothing Then _
        Unload g_show
    DoShutdown              ' Saves parameters for next start
    
End Sub



Private Sub picASCOM_Click()

    DisplayWebPage "http://ascom-standards.org/"
    
End Sub

Private Sub cmdSetup_Click()

    DoSetup                         ' May change our topmost state
    
End Sub



Private Sub cmdTraffic_Click()

    If g_show Is Nothing Then
        Set g_show = New frmShow
        g_show.TextOffset = 1425
    End If
    
    g_show.Show
    
End Sub


' =================
' PUBLIC PROPERTIES
' =================

Public Property Let Position(val As Long)

    PositionTF.Caption = val
    
End Property


Public Property Get ButtonState() As Integer

    ' race condition check, ignore if down just occuring
    If downclick Then
        downclick = False
        ButtonState = 0     ' button not realy down yet
        Exit Sub
    End If
    
    ButtonState = BtnDebounce
    
    If BtnState = 0 Then _
        BtnDebounce = 0
End Property

' ==============
' LOCAL ROUTINES
' ==============

'SERVO ATTACHING
Private Sub PhidgetManager_OnAttach(ByVal PHIDGET As PHIDGET.IPhidget)
    Dim i As Single
    If PHIDGET.DeviceType = "PhidgetServo" Then
        If Servo Is Nothing Then
            'Assign the generic Phidget to the Servo object
            Set Servo = PHIDGET
            
            ' mrh - move to a center position
            Servo.MotorPosition(0) = g_lMinDeg + 0.5 * (g_lMaxDeg - g_lMinDeg)
            
            g_handBox.Position = fromDegrees(Servo.MotorPosition(0))

            'Show the current Servo information
            'lblMessage.Caption = "PhidgetServo Attached"
            'lblNumMotors.Caption = Servo.NumMotors
            'lblSerialNumber.Caption = Servo.SerialNumber
        End If
    End If
End Sub

'SERVO DETACHING: Clean up.
Private Sub PhidgetManager_OnDetach(ByVal PHIDGET As PHIDGET.IPhidget)
    If PHIDGET.DeviceType = "PhidgetServo" Then
        If Not (Servo Is Nothing) Then
            If PHIDGET.SerialNumber = Servo.SerialNumber Then
                Set Servo = Nothing
            End If
        End If
    End If
End Sub


