VERSION 5.00
Begin VB.Form frmSetup 
   BackColor       =   &H00000000&
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "ASCOM Phidget Focuser Setup"
   ClientHeight    =   4425
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   4515
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4405.927
   ScaleMode       =   0  'User
   ScaleWidth      =   4515
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame1 
      BackColor       =   &H00000000&
      Caption         =   "Focuser Settings"
      ForeColor       =   &H00FFFFFF&
      Height          =   2460
      Left            =   360
      TabIndex        =   5
      Top             =   240
      Width           =   3735
      Begin VB.TextBox StepSizeTF 
         Height          =   375
         Left            =   1920
         TabIndex        =   10
         ToolTipText     =   "Focuser can't go beyond this"
         Top             =   1560
         Width           =   1455
      End
      Begin VB.TextBox MaxDegTF 
         Height          =   375
         Left            =   1920
         TabIndex        =   7
         ToolTipText     =   "Focuser can't go beyond this"
         Top             =   1080
         Width           =   1455
      End
      Begin VB.TextBox MinDegTF 
         Height          =   375
         Left            =   1920
         TabIndex        =   6
         ToolTipText     =   "Focuser can't go beyond this"
         Top             =   600
         Width           =   1455
      End
      Begin VB.Label StepSizeL 
         BackColor       =   &H00000000&
         Caption         =   "Step Size (Microns):"
         ForeColor       =   &H00FFFFFF&
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   11
         Top             =   1680
         Width           =   1455
      End
      Begin VB.Label MaxDegL 
         BackColor       =   &H00000000&
         Caption         =   "Servo Max (Deg):"
         ForeColor       =   &H00FFFFFF&
         Height          =   255
         Index           =   0
         Left            =   360
         TabIndex        =   9
         Top             =   1200
         Width           =   1455
      End
      Begin VB.Label MinDegL 
         BackColor       =   &H00000000&
         Caption         =   "Servo Min (Deg):"
         ForeColor       =   &H00FFFFFF&
         Height          =   255
         Index           =   1
         Left            =   360
         TabIndex        =   8
         Top             =   720
         Width           =   1455
      End
   End
   Begin VB.PictureBox picASCOM 
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   840
      Left            =   510
      MouseIcon       =   "frmSetup.frx":0000
      MousePointer    =   99  'Custom
      Picture         =   "frmSetup.frx":0152
      ScaleHeight     =   840
      ScaleWidth      =   720
      TabIndex        =   4
      Top             =   3120
      Width           =   720
   End
   Begin VB.CheckBox chkAlwaysTop 
      BackColor       =   &H00000000&
      Caption         =   "Always on Top"
      ForeColor       =   &H00FFFFFF&
      Height          =   255
      Left            =   1665
      TabIndex        =   0
      ToolTipText     =   "Focus handset will float on top"
      Top             =   3120
      Value           =   1  'Checked
      Width           =   1575
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   345
      Left            =   1560
      TabIndex        =   1
      Top             =   3600
      Width           =   930
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Height          =   345
      Left            =   3000
      TabIndex        =   2
      Top             =   3600
      Width           =   930
   End
   Begin VB.Label lblDriverInfo 
      BackColor       =   &H00000000&
      Caption         =   "<run time - version etc.>"
      ForeColor       =   &H00FFFFFF&
      Height          =   240
      Left            =   120
      TabIndex        =   3
      Top             =   6840
      Width           =   5295
   End
End
Attribute VB_Name = "frmSetup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Option Explicit

Private m_bResult As Boolean
Private m_bAllowUnload As Boolean
Private m_bAdvancedMode As Boolean

' ======
' EVENTS
' ======

Private Sub Form_Load()
    
    FloatWindow Me.hwnd, True                   ' Setup window always floats
    m_bAllowUnload = True                       ' Start out allowing unload

    lblDriverInfo = App.FileDescription & _
                " Version " & App.Major & "." & _
                App.Minor & "." & App.Revision
    
End Sub

Private Sub Form_Unload(Cancel As Integer)

    Me.Hide                                     ' Assure we don't unload
    Cancel = Not m_bAllowUnload                 ' Unless our flag permits it
    
End Sub


Private Sub cmdOK_Click()

    m_bResult = True
    Me.Hide

End Sub

Private Sub cmdCancel_Click()

    m_bResult = False
    Me.Hide

End Sub


Private Sub picASCOM_Click()

    DisplayWebPage "http://ascom-standards.org/"
    
End Sub

' =================
' PUBLIC PROPERTIES
' =================

Public Property Get Result() As Boolean

    Result = m_bResult              ' Set by OK or Cancel button
    
End Property
Public Property Get MinDeg() As Long

    MinDeg = CLng(MinDegTF)
        
End Property

Public Property Get MaxDeg() As Long

    MaxDeg = CLng(MaxDegTF)
        
End Property

Public Property Let MaxDeg(ByVal val As Long)

    MaxDegTF = Format$(val, "0")     ' No decimal digits

End Property
Public Property Let MinDeg(ByVal val As Long)

    MinDegTF = Format$(val, "0")     ' No decimal digits

End Property
Public Property Get StepSize() As Double

    StepSize = CDbl(StepSizeTF)
        
End Property

Public Property Let StepSize(ByVal val As Double)

    StepSizeTF = Format$(val, "0")     ' No decimal digits

End Property

Public Property Let AllowUnload(b As Boolean)

    m_bAllowUnload = b
    
End Property

'
' LOCAL UTILITIES
'

